package LATMOS::Accounts::Web::Controller::Json::Expire;
use Moose;
use namespace::autoclean;

BEGIN { extends 'Catalyst::Controller'; }

=head1 NAME

LATMOS::Accounts::Web::Controller::Json::Expire - Catalyst Controller

=head1 DESCRIPTION

Catalyst Controller.

=head1 METHODS

=cut


=head2 index

=cut

sub index :Path :Args(0) {
    my ( $self, $c ) = @_;

    my $base = $c->model('Accounts')->db;

    my $graph = {
        data => [],
        series => [],
    };

    my @exists = $base->search_objects('user', 'active=1', 'givenName=*');
    my %results = $base->attributes_summary_by_object('user', 'expire');
    my %contrats = $base->attributes_summary_by_object('user', 'contratType');
    
    my %dates;
    foreach my $user (@exists) {
        if (my $d = $results{$user}) {
            my $contrat = $contrats{$user}[0] || '(none)';
            foreach (@{ $results{$user} }) {
                $_ or next;
                $_ =~ s/:\d\d\+\d\d$//;
                $dates{$contrat}{$_} ||= 0;
                $dates{$contrat}{$_} ++;
            }
        }
    }

    foreach my $contrat (sort keys %dates) {
        push(@{ $graph->{data} }, [ map { [ $_, $dates{$contrat}{$_} +0 ] } sort { $dates{$contrat}{$b} <=> $dates{$contrat}{$a} } keys %{ $dates{$contrat} } ]);
        push(@{ $graph->{series} }, { label => $contrat });
    } 
    
    $c->stash->{data} = $graph;
}



=encoding utf8

=head1 AUTHOR

Olivier Thauvin,Guyancourt - B1428,+33 1 80285052,

=head1 LICENSE

This library is free software. You can redistribute it and/or modify
it under the same terms as Perl itself.

=cut

__PACKAGE__->meta->make_immutable;

1;
